function [MSE,MSEnew]=RegMSE(X,Y,varargin)
% FORMAT [MSE,MSEnew] = RegMSE(X,Y,[Xnew,Ynew,lamb])
%
%

if nargin>2
  Xnew = varargin{1};
  Ynew = varargin{2};
else
  Xnew = [];
  Ynew = [];
end
if nargin>4
  lamb = varargin{3};
else
  lamb = 0;
end

MSE    = zeros(size(lamb));
MSEnew = zeros(size(lamb));

for nl = 1:numel(lamb)

  DM = [ones(size(X,1),1) X];  % Design matrix
  if lamb(nl)==0
    wh = pinv(DM)*Y;           % w-hat
  else
    wh = pinv(DM'*DM + lamb(nl)*eye(size(DM,2)))*DM'*Y;
  end
  Yh = DM*wh;                % Y-hat

  MSE(nl) = mean((Y-Yh).^2);

  if ~isempty(Xnew)
    DMnew = [ones(size(Xnew,1),1) Xnew];  
    Ynewh = DMnew*wh;
    MSEnew(nl) = mean((Ynew-Ynewh).^2);
  end
end


